CREATE TABLE pref_node (
	id        NUMBER(19, 0) NOT NULL,
	parent_id NUMBER(19, 0),
	name      VARCHAR2(80) NOT NULL,
	username  VARCHAR2(255),
	created   TIMESTAMP(6) NOT NULL
);

ALTER TABLE pref_node ADD CONSTRAINT pk_pref_node PRIMARY KEY id;
ALTER TABLE pref_node ADD CONSTRAINT fk_pref_node_parent_id FOREIGN KEY parent_id REFERENCES pref_node(id);
CREATE INDEX ix_pref_node_parent_id ON pref_node(parent_id);
CREATE INDEX ix_pref_node_username ON pref_node(username);

CREATE TABLE pref_property (
	id       NUMBER(19, 0) NOT NULL,
	node_id  NUMBER(19, 0) NOT NULL,
	name     VARCHAR2(80) NOT NULL,
	value    VARCHAR2(4000),
	created  TIMESTAMP(6) NOT NULL,
	modified TIMESTAMP(6) NOT NULL
);

ALTER TABLE pref_property ADD CONSTRAINT pk_pref_property PRIMARY KEY id;
ALTER TABLE pref_property ADD CONSTRAINT fk_pref_property_node_id FOREIGN KEY node_id REFERENCES pref_node(id);
CREATE INDEX ix_pref_property_node_id ON pref_property(node_id);

CREATE SEQUENCE sq_pref_node START WITH 1;
CREATE SEQUENCE sq_pref_property START WITH 1;
