package org.svaor.preferences;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * Preferences provider
 * todo NoSQL implementation - ?
 * @author Smelik Evgeniy
 */
public interface PreferencesProvider {
	@NotNull
	Long loadOrCreateRootNode(@Nullable String username);

	@NotNull
	Long[] setProperty(@NotNull Long rootNodeId, @Nullable String[] nodeNames, @NotNull String propertyName, @NotNull String propertyValue);

	@Nullable
	String getProperty(@NotNull Long nodeId, @NotNull String propertyKey);

	void removeProperty(@NotNull Long nodeId, @NotNull String propertyKey);

	void removeNode(@NotNull Long nodeId);

	@NotNull
	String[] getPropertyKeys(@NotNull Long nodeId);

	@NotNull
	String[] getNodeNames(@NotNull Long nodeId);

	@Nullable
	Long loadNode(@NotNull Long parentNodeId, @NotNull String childNodeName);
}
