package org.svaor.preferences;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.prefs.BackingStoreException;

/**
 * This preference service is used by main {@link PreferencesImpl}. Results of this class's method callings can be cached
 * @see ClientCachingPreferencesServiceImpl
 * @author Smelik Evgeniy
 */
public interface PreferencesService {
	String PREFERENCES_NAME_SEPARATOR = "/";

	@NotNull
	Long loadOrCreateRootNode(@Nullable String username);

	@NotNull
	Long[] setProperty(@NotNull Long rootNodeId, @Nullable String[] nodeNames, @NotNull String nodePath, @NotNull String key, @NotNull String value);

	@Nullable
	String getProperty(@NotNull String nodePath, @Nullable Long nodeId, @NotNull String key);

	void removeProperty(@NotNull String nodePath, @NotNull Long nodeId, @NotNull String key);

	void removeNode(@NotNull String parentNodePath, @NotNull String nodeName, @NotNull Long nodeId) throws BackingStoreException;

	@NotNull
	String[] getPropertyKeys(@NotNull String nodePath, @Nullable Long nodeId) throws BackingStoreException;

	@NotNull
	String[] getNodeNames(@NotNull String nodePath, @Nullable Long nodeId) throws BackingStoreException;

	@Nullable
	Long loadNode(@NotNull String parentNodePath, @NotNull Long parentNodeId, @NotNull String childNodeName);
}
