package org.svaor.preferences.model;

import org.jetbrains.annotations.NotNull;

import java.io.Serializable;
import java.util.Date;

/**
 * Preferences property
 * @author Smelik Evgeniy
 */
public interface Property extends Serializable, Cloneable {
	long getId();

	@NotNull
	Node getNode();

	@NotNull
	String getName();

	@NotNull
	String getValue();

	void setValue(@NotNull String value);

	Date getCreationDate();

	Date getModifiedDate();

	void setModifiedDate(Date modifiedDate);
}
