package org.svaor.preferences.provider.model;

import org.svaor.preferences.model.Node;
import org.svaor.preferences.model.Property;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.jetbrains.annotations.NotNull;

import java.util.Date;

import static org.apache.commons.lang.builder.ToStringStyle.SHORT_PREFIX_STYLE;

/** @author Smelik Evgeniy */
public class PropertyImpl implements Property {
	@SuppressWarnings({"UnusedDeclaration"})
	private Long id;
	@NotNull
	private String name;
	@NotNull
	private String value;
	@NotNull
	private Date created = new Date();
	@NotNull
	private Date modified = new Date();
	@NotNull
	private Node node;

	public PropertyImpl() {
	}

	public PropertyImpl(@NotNull String name, @NotNull String value, @NotNull Node node) {
		this.name = name;
		this.value = value;
		this.node = node;
	}

	@Override
	public long getId() {
		return id;
	}

	@NotNull
	@Override
	public Node getNode() {
		return node;
	}

	public void setNode(@NotNull Node node) {
		this.node = node;
	}

	@NotNull
	@Override
	public String getName() {
		return name;
	}

	public void setName(@NotNull String name) {
		this.name = name;
	}

	@NotNull
	@Override
	public String getValue() {
		return value;
	}

	@Override
	public void setValue(@NotNull String value) {
		this.value = value;
	}

	@Override
	public Date getCreationDate() {
		return created;
	}

	@Override
	public Date getModifiedDate() {
		return modified;
	}

	@Override
	public void setModifiedDate(Date modified) {
		this.modified = modified;
	}

	@Override
	public String toString() {
		return new ToStringBuilder(this, SHORT_PREFIX_STYLE).
				append("id", id).
				append("name", name).
				append("value", value).
				append("node", node).
				toString();
	}
}
