package org.svaor.preferences;

import org.jetbrains.annotations.NotNull;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.prefs.Preferences;

/** @author Smelik Evgeniy */
public abstract class AbstractPreferencesTest extends AbstractPreferencesLowLevelTest {
	private final Logger log = LoggerFactory.getLogger(AbstractPreferencesTest.class);

	protected static final Class CLASS_FOR_PREFERENCES = AbstractPreferencesTest.class;

	@NotNull
	protected Preferences preferences;

	public AbstractPreferencesTest() {
	}

	protected void preparePreferences() {
		if (log.isDebugEnabled()) {
			log.debug("Preparing system node Preferences for class [" + CLASS_FOR_PREFERENCES.getName() + ']');
		}
		preferences = Preferences.systemNodeForPackage(CLASS_FOR_PREFERENCES);
	}
}
