package org.svaor.preferences;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.util.ReflectionUtils;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.util.prefs.Preferences;
import java.util.prefs.PreferencesFactory;

import static org.fluentjava.FluentUtils.cast;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

/**
 * Preferences factory service provider test.
 * @author Smelik Evgeniy
 */
@ContextConfiguration(locations = {"classpath:/org/svaor/preferences/provider/test-preferences-context.xml"})
@RunWith(SpringJUnit4ClassRunner.class)
public class PreferencesFactoryImplTest {
	public PreferencesFactoryImplTest() {
	}

	@Test
	public void testServiceProvider() throws InvocationTargetException, NoSuchMethodException, IllegalAccessException {
		final Class classPreferences = Preferences.class;
		final Field preferencesFactoryField = ReflectionUtils.findField(classPreferences, "factory", PreferencesFactory.class);
		ReflectionUtils.makeAccessible(preferencesFactoryField);
		final PreferencesFactory preferencesFactory = cast(ReflectionUtils.getField(preferencesFactoryField, null));

		assertNotNull(preferencesFactory);
		assertEquals(PreferencesFactoryImpl.class, preferencesFactory.getClass());
	}
}
