package org.svaor.preferences;

import org.junit.BeforeClass;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.prefs.Preferences;

/**
 * Basic top-level test for database preferences API implementation - system node.
 * @author Smelik Evgeniy
 */
public class PreferencesSystemNodeTest extends AbstractPreferencesTopLevelTest {
	private static final Logger log = LoggerFactory.getLogger(PreferencesSystemNodeTest.class);

	public PreferencesSystemNodeTest() {
	}

	@BeforeClass
	public static void beforeTest() {
		log.info("Testing system node");
	}

	@Override
	protected void prepareUser() {
		username = null;
	}

	@Override
	protected void preparePreferences() {
		if (log.isDebugEnabled()) {
			log.debug("Preparing system node Preferences for class [" + CLASS_FOR_PREFERENCES.getName() + ']');
		}
		preferences = Preferences.systemNodeForPackage(CLASS_FOR_PREFERENCES);
	}
}
