package org.svaor.preferences;

import org.junit.BeforeClass;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.security.core.context.SecurityContextHolder;

import java.util.prefs.Preferences;

/**
 * Basic top-level test for database preferences API implementation - user node.
 * @author Smelik Evgeniy
 */
public class PreferencesUserNodeTest extends AbstractPreferencesTopLevelTest {
	private static final Logger log = LoggerFactory.getLogger(PreferencesUserNodeTest.class);

	public static final String USERNAME_TEST = "testUsername";

	public PreferencesUserNodeTest() {
	}

	@BeforeClass
	public static void beforeTest() {
		log.info("Testing user node for username [" + USERNAME_TEST + ']');
	}

	@Override
	protected void prepareUser() {
		username = USERNAME_TEST;
		final UsernamePasswordAuthenticationToken token = new UsernamePasswordAuthenticationToken(username, "");
		SecurityContextHolder.getContext().setAuthentication(token);
	}

	@Override
	protected void preparePreferences() {
		if (log.isDebugEnabled()) {
			log.debug("Preparing user node Preferences for class [" + CLASS_FOR_PREFERENCES.getName() + ']');
		}
		preferences = Preferences.userNodeForPackage(CLASS_FOR_PREFERENCES);
	}
}
